package repository

import (
	"actatempus_backend/internal/domain/entities"
	"context"

	E "github.com/IBM/fp-go/either"
)

// ProjectTaskRepository defines the operations for interacting with project task data.
type ProjectTaskRepository interface {
	Create(ctx context.Context) func(task entities.ProjectTaskCreate) E.Either[error, entities.ProjectTask]
	FindByID(ctx context.Context) func(id string) E.Either[error, entities.ProjectTask]
	FindByProjectID(ctx context.Context) func(projectID string) E.Either[error, []entities.ProjectTask]
	Update(ctx context.Context) func(task entities.ProjectTaskUpdate) E.Either[error, entities.ProjectTask]
	Delete(ctx context.Context) func(id string) E.Either[error, entities.ProjectTask]
	FindAll(ctx context.Context) E.Either[error, []entities.ProjectTask]
}
